<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: sequence_kernel_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_556deba3bfc0e2c1d58ae0e1ee4b27b3.html">sequence</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">sequence_kernel_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2003  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_SEQUENCE_KERNEl_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_SEQUENCE_KERNEl_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../interfaces/enumerable.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../interfaces/remover.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../serialize.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="keyword">typename</span> mem_manager = <a class="code" href="namespacedlib.html#ae8aaef18fce6452263f46535116308ca">default_memory_manager</a></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        &gt;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keyword">class </span>sequence : <span class="keyword">public</span> enumerable&lt;T&gt;,</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;                     <span class="keyword">public</span> remover&lt;T&gt;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    {</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keyword">public</span>:</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            <span class="keyword">typedef</span> T type;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            <span class="keyword">typedef</span> mem_manager mem_manager_type;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            sequence (</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            );</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            <span class="keyword">virtual</span> ~sequence (</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;            ); </div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            <span class="keywordtype">void</span> clear (</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;            );</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            <span class="keywordtype">void</span> add (</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;                <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> pos,</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;                T&amp; item</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            );</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            <span class="keywordtype">void</span> remove (</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;                <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> pos,</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;                T&amp; item</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            );</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            <span class="keywordtype">void</span> cat (</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;                sequence&amp; item</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;            );</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;            <span class="keyword">const</span> T&amp; operator[] (</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;                <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> pos</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;            ) <span class="keyword">const</span>;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            T&amp; operator[] (</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> pos</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;            );</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;                sequence&amp; item</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            );</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="keyword">private</span>:</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160; </div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            <span class="comment">// restricted functions</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            sequence(sequence&amp;);        <span class="comment">// copy constructor</span></div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            sequence&amp; operator=(sequence&amp;);    <span class="comment">// assignment operator        </span></div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160; </div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    };</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160; </div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keyword">typename</span> mem_manager</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        &gt;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        sequence&lt;T,mem_manager&gt;&amp; a, </div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        sequence&lt;T,mem_manager&gt;&amp; b </div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    ) { a.swap(b); }  </div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        <span class="keyword">typename</span> mem_manager</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        &gt;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="keywordtype">void</span> deserialize (</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        sequence&lt;T,mem_manager&gt;&amp; item, </div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        std::istream&amp; in</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    );   </div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;}</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160; </div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="preprocessor">#endif // DLIB_SEQUENCE_KERNEl_ABSTRACT_</span></div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html_ae8aaef18fce6452263f46535116308ca"><div class="ttname"><a href="namespacedlib.html#ae8aaef18fce6452263f46535116308ca">dlib::default_memory_manager</a></div><div class="ttdeci">memory_manager_stateless_kernel_1&lt; char &gt; default_memory_manager</div><div class="ttdef"><b>Definition:</b> algs.h:129</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
